
 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.Passage.Globals"
 import "Homeopatix.Passage.MinimizedIcon"
 import "Homeopatix.Passage.VindarPatch"
 import "Homeopatix.Passage.Commands"
 import "Homeopatix.Passage.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Passage</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = settings.shortcutData_1;
   		settings.shortcutData_2 = settings.shortcutData_2;
   		settings.shortcutData_3 = settings.shortcutData_3;
   
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "Passage_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
PassageWindow=Turbine.UI.Lotro.GoldWindow(); 
PassageWindow:SetSize(200,120); 
PassageWindow:SetText(Strings.PluginName); 
PassageWindow.Message=Turbine.UI.Label(); 
PassageWindow.Message:SetParent(PassageWindow); 
PassageWindow.Message:SetSize(150,15); 
PassageWindow.Message:SetPosition(PassageWindow:GetWidth()/2 - 75, PassageWindow:GetHeight()/2 + 40); 
PassageWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
PassageWindow.Message:SetText(Strings.PluginText); 
PassageWindow:SetWantsKeyEvents(true);

function PassageWindow:Closing(sender, args)
	settings.isWindowVisible = false;
end


PassageWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, PassageWindow:SetVisible(false));

MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
settings.isWindowVisible = false;
SaveSettings();
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( PassageWindow );
centerWindow:SetPosition( 41 ,PassageWindow:GetHeight()/2 - 12);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( PassageWindow );
centerWindow2:SetPosition( 79 ,PassageWindow:GetHeight()/2 - 12);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow3 = Turbine.UI.Extensions.SimpleWindow();
centerWindow3:SetSize( 36 , 36 );
centerWindow3:SetParent( PassageWindow );
centerWindow3:SetPosition( 117,PassageWindow:GetHeight()/2 - 12);
centerWindow3:SetVisible( true );
centerWindow3:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow3);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

centerQS3 = Turbine.UI.Lotro.Quickslot();
centerQS3:SetParent( centerWindow3 );
centerQS3:SetPosition( 0, 0 );
centerQS3:SetSize( 35, 35 );
centerQS3:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------
if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_1, settings.shortcutData_1 ) );
end
if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_2, settings.shortcutData_2 ) );
end
if(settings.shortcutData_3 ~= "") then
	centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_3, settings.shortcutData_3 ) );
end

settings.shortcutData_1 = "0x70003F45"; -- morceaux de fruit pourrit non theatre
settings.shortcutData_2 = "0x70003F46"; -- ptale de fleurs de rivegel
settings.shortcutData_3 = "0x70003F47"; -- morceaux de fruit pourri pour le theatre
centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_1 ) );
centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_2 ) );
centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_3 ) );


------------------------------------------------------------------------------------------
-- mouse click handler
------------------------------------------------------------------------------------------
centerQS1.MouseEnter = function(sender, args)
	PassageWindow.Message:SetText(""); 
	PassageWindow.Message:SetText(Strings.PluginPassage1); 
end

centerQS2.MouseEnter = function(sender, args)
	PassageWindow.Message:SetText("");
	PassageWindow.Message:SetText(Strings.PluginPassage2); 
end

centerQS3.MouseEnter = function(sender, args)
	PassageWindow.Message:SetText("");
	PassageWindow.Message:SetText(Strings.PluginPassage3); 
end

centerQS1.MouseLeave = function(sender, args)
	PassageWindow.Message:SetText(Strings.PluginText);
end

centerQS2.MouseLeave = function(sender, args)
	PassageWindow.Message:SetText(Strings.PluginText);
end

centerQS3.MouseLeave = function(sender, args)
	PassageWindow.Message:SetText(Strings.PluginText);
end

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS3.MouseWheel = function(sender, args)
	settings.shortcutData_3 = tostring(""); 
	centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end
centerQS3.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS3:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_3 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------

PassageWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		PassageWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			PassageWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			PassageWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	PassageWindow.PositionChanged = function( sender, args )
    	local x,y = PassageWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



